#!/usr/bin/env groovy
library identifier: 'shared-library@master',
    retriever: modernSCM([
        $class: 'GitSCMSource',
        credentialsId: 'devopsautomate', 
        remote: 'https://gitlab.com/evry-platform/jenkins-pipeline-library.git'
    ])

def envVars = [
    'develop': [
        envName: 'alpha',
        namespace: 'alpha-evrynet-floodgate'
    ],
		'tag': [
				envName: 'beta',
        namespace: 'beta-evrynet-floodgate'	
		]
]
def serviceNameList = [ 
    "sp1g0t"
]
//Adjustable Parameter
def projectName = "sp1g0t"
def pipelineType = "backend"
def repoAppConfig = "gitlab.com/evrynet/floodgate/environments"
def imageName = "registry.gitlab.com/evrynet/floodgate/sp1g0t"

node('slave'){
    def dockerfile = "Dockerfile"
    def commitHash = checkout(scm).GIT_COMMIT
    def gitCommitShort =  commitHash.substring(0, 11)
    def dockerTag = "${env.BRANCH_NAME}-${gitCommitShort}-${env.BUILD_NUMBER}"
		def image = "${imageName}:${dockerTag}"
    // def scannerHome = tool 'sonarqube-scanner'

		// Start Pipeline
		stageCloneRepository()
    stageCleanup()

    if(env.TAG_NAME != null) {
				stageBuildDocker(
            dockerfile,
            projectName,
            image,
            pipelineType,
            envVars['tag']['envName'])
        stageCloneAppConfig(
            repoAppConfig)
        stageApplyAppConfig(
            serviceNameList,
            projectName,
            envVars['tag']['envName'],
            envVars['tag']['namespace'])
        stageHelmDeploy(
            dockerTag,
            projectName,
            envVars['tag']['envName'],
            envVars['tag']['namespace'])
    }else if(env.BRANCH_NAME in ['develop']) {
        // stageSonarqubeAnalysis(
        //     dockerTag,
        //     projectName,
        //     scannerHome) 
        stageBuildDocker(
            dockerfile,
            projectName,
            image,
            pipelineType,
            envVars[env.BRANCH_NAME]['envName'])
        stageCloneAppConfig(
            repoAppConfig)
        stageApplyAppConfig(
            serviceNameList,
            projectName,
            envVars[env.BRANCH_NAME]['envName'],
            envVars[env.BRANCH_NAME]['namespace'])
        stageHelmDeploy(
            dockerTag,
            projectName,
            envVars[env.BRANCH_NAME]['envName'],
            envVars[env.BRANCH_NAME]['namespace'])
    }
}
